//+------------------------------------------------------------------+
//|                                      .mq4 |
//+------------------------------------------------------------------+
//|------------------------------------------------------------------+

#property copyright "Copyright  2005, klot"
#property link      "klot@mail.ru"
#define MAGICEXP 00000001
#include <stdlib.mqh>
//---
#include <WinUser32.mqh>
//---
#import "#_lib_NeuroFFT.ex4"
void InitNet_WW_BP(string NameWW, double& ww[][][]);
void InNormalize(double& aa[]);
void PredObrabotka(double in[],double& bb[]);
void realfastfouriertransform(double& a[], int tnn, bool inversefft);
void NeuroNet_BP(string NameWW, double in[], double& ww[][][], double& Out_Net[], 
                int N1, int N2, int N3, bool Tranning=false, double myu=0.0001);
double F_Target(double aa[], double bb[], int N);
#import
//---
//-------------------------------------------------------------------+
extern double Lots= 0.1;
//-------------------------------------------------------------------+
//    ind_collect -   6 - 64 
extern double n=6;
//-------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                               |
//+------------------------------------------------------------------+
   string Name_Net="Vasya;64;64;7"; //   
   string Net_param[4];
   //---
   //string Name_Pat="P;79;64;65"; //   
   //double in_pattern[][65];

   double in_neuro[64];
   double Vasya_WW1[64][64][3]; // ()   Wi *  Nj *  Ll
   double Out_Net1[]; //  1
   int N1,N2,N3;
   //-----------------------------------------------------------------+
   double ind_collect[];
   int NN,nn;
   //---
   //----------------------------------------------------------------+
   //|                                   |
   //----------------------------------------------------------------+
   double Buy_t[7]={1.0,-1.0,-1.0,1.0,-1.0,-1.0,1.0};
   double Sell_t[7]={-1.0,1.0,1.0,-1.0,1.0,1.0,-1.0}; 
   double No_trade[7]={0.0,0.0,0.0,0.0,0.0,0.0,0.0}; 
   //---
   double Buy,Sell,FTarget;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   //+------------------------------------------------------------------+
   //|               WWW[][][]                   |
   //|                          |
   //|               |
   //+------------------------------------------------------------------+
   InitNet_WW_BP(Name_Net, Vasya_WW1);
   //---
   //ReadPattern(Name_Pat,in_pattern);
   //---
   int count=StrSplit(Name_Net,Net_param,";");
   if (count!=4)
   {
      Print("    ");
      return(0);
   }
   //---
   N1=StrToInteger(Net_param[1]); //    
   N2=StrToInteger(Net_param[2]); //   2- 
   N3=StrToInteger(Net_param[3]); //    
   //---
   nn=MathPow(2,n);
   NN=ArrayResize(ind_collect,nn);
//----
   //    
  if(!GlobalVariableCheck("signal"))  GlobalVariableSet("signal",0);
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
if(GlobalVariableCheck("signal"))  GlobalVariableDel("signal");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   //=============================================================================
   // if(IsOptimization()) return(0);
   //=============================================================================
   int pos=Check_for_open_pos();//   
   //---
   //=========================== =================================
   //----------------------------------------------------------------------------+
   //|                                                       |
   //|      NN -                         |
   //|           ,   ..              |
   //----------------------------------------------------------------------------+
   double ZZ;
   datetime some_time;
   static int nBar;
   int bigshift, i;
   //---

   ZZ=iCustom(NULL,60,"DT_ZZ",5,0,0);

           //---
         for( i=0; i<=NN-1; i++)
         {
            //ZZ=iCustom(NULL,60,"DT_ZZ",5,0,iBarShift(NULL,60,iTime(NULL,0,i)));
            ind_collect[i]=iBWMFI(NULL, 0, i+1);
            //iCustom(NULL,0,"0_reg",NN,3,0,0,i+1);
         }
    
     
    //Comment(" ind_collect[0]= ",ind_collect[0], " ind_collect[1]= ",ind_collect[1],
    //       " ind_collect[2]= ",ind_collect[2], " ind_collect[3]= ",ind_collect[3]);
    
    
   //----------------------------------------------------------------------------+
   //|                                       |
   //|    -    ,   ..                     |
   //|           ind_collect[NN]                                           |
   //|    -    FFT ,                           |
   //|                                           |
   //|     in_neuro[Nin] =     Nin=NN/2   |
   //|                                                     |
   //|            int Nin=ArraySize(in_neuro);                                   |
   //|    ,                     |
   //----------------------------------------------------------------------------+
   //---
   //PredObrabotka(ind_collect,in_neuro);
   //----------------------------------------------------------------+
   //|                                        |
   //----------------------------------------------------------------+
   static double Sum_old=0;
   double Sum_in=0;
   //      
   for(int p=0; p<=NN-1; p++) { Sum_in+=ind_collect[p]; }
   if(Sum_in!=Sum_old) 
   { 
     ArrayCopy(in_neuro,ind_collect);
     //---
     InNormalize(in_neuro);
     //---
     //Comment("  !!!!! ");
   }
   Sum_old=Sum_in;
   //---
 
   
   //---
   //----------------------------------------------------------------------------+
   //|                                                               |
   //----------------------------------------------------------------------------+
   NeuroNet_BP(Name_Net, in_neuro, Vasya_WW1, Out_Net1, N1, N2, N3,false,0);
   //---
   //----------------------------------------------------------------------------+
   //|  F_Target   Ed=Sum(P,(outNet[p,N]-Target[p])^2)/2;   |
   //|     :)                                                   |
   //----------------------------------------------------------------------------+
   //---
   Buy=1-F_Target(Out_Net1,Buy_t,N3);
   Sell=1-F_Target(Out_Net1,Sell_t,N3);
   //---
   Comment("Buy= ", Buy," Sell= ",Sell," ZZ= ",ZZ);
   //---
   static datetime lastsd;
   //---
   if ( CurTime()-lastsd>6*60*Period() )
   { 
      if(ZZ>=High[1] && Sell>=0.9999 ) 
      {
         sell_open(0,0);
         close_order(1);
         
         lastsd=CurTime();
      }
      if(ZZ!=0 && ZZ<=Low[1] && Buy>=0.9999 ) 
      {
         
         buy_open(0,0);
         close_order(-1);
         
         lastsd=CurTime();
         
      }
      
   }
   //---
   // --- .      ------------
   //------------------------------------------------------------------
   int    obj_total=ObjectsTotal();
   string name;
   double sig;
   //---
   if(GlobalVariableCheck("signal")) sig=GlobalVariableGet("signal");
   //---
   if( sig==-1 )
      { 
         NeuroNet_BP(Name_Net, in_neuro, Vasya_WW1, Sell_t, N1, N2, N3, true, 0.001);
         //---
         for( i=0;i<obj_total;i++)
         {
            name=ObjectName(i);
            //Print(i,":   - ",name);
         }
         if (name!="UP "+nBar+" ")
         {  
            ObjectCreate("UP "+nBar+" ", OBJ_ARROW, 0, Time[0], High[0]);
            ObjectSet("UP "+nBar+" ", OBJPROP_ARROWCODE, 242);
         }
      }
   if( sig==1 ) 
      { 
         NeuroNet_BP(Name_Net, in_neuro, Vasya_WW1, Buy_t, N1, N2, N3, true, 0.001);
         //---
         for( i=0;i<obj_total;i++)
         {
            name=ObjectName(i);
            //Print(i,":   - ",name);
         }
         if (name!="LO "+nBar+" ")
         {
            ObjectCreate("LO "+nBar+" ", OBJ_ARROW, 0, Time[0], Low[0]);
            ObjectSet("LO "+nBar+" ", OBJPROP_ARROWCODE, 241);
         }
      }
   //-----------------------------------------------------------------------
   
   
   ts();
   
   
   //---
   return(0);
  }

//===================================================================+
//                                                    |
//===================================================================+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void buy_open(double SL, double TP)
  {
   int ticket, lasterror;
   RefreshRates();
   ticket = OrderSend(Symbol(),OP_BUY,Lots,MarketInfo(Symbol(),MODE_ASK),5,SL,TP,0,MAGICEXP,0,Aqua);
   if(ticket > 0)
     { 
       if(OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
           Print("BUY order opened : ", OrderOpenPrice());
//---  
     }
   else 
       Print("Error opening BUY order : ", ErrorDescription(GetLastError())); 
   return;
  } 
//===================================================================+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void sell_open(double SL, double TP)
  {
   int ticket, lasterror;
   RefreshRates();
   ticket = OrderSend(Symbol(),OP_SELL,Lots,MarketInfo(Symbol(),MODE_BID),5,SL,TP,0,MAGICEXP,0,Red);
   if(ticket > 0)
     {
       if(OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
           Print("Sell order opened : ", OrderOpenPrice());
//---
     }
   else 
       Print("Error opening Sell order : ", ErrorDescription(GetLastError())); 
   return;
  } 
//===================================================================+
//+------------------------------------------------------------------+
//|     n=1 -  Buy, n=-1 -  Sell        |
//+------------------------------------------------------------------+
void close_order(int n = 0)
  {
   int nGetLastError;
   int nOrdersTotal = OrdersTotal();
//----
   for(int i = nOrdersTotal - 1; i >= 0; i--)
     {
       OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       nGetLastError = GetLastError();
       //----
       if(nGetLastError != 0)
         { 
           Print("Error selecting order : ", ErrorDescription(nGetLastError)); 
           continue;
         }
       //----
       if(OrderMagicNumber() != MAGICEXP || OrderSymbol() != Symbol())  continue;
       //---- check order type 
       if(OrderType() == OP_BUY && n == 1)
         {
           //----
               RefreshRates();
               OrderClose(OrderTicket(), OrderLots(),MarketInfo(Symbol(),MODE_BID), 3, Aqua);
               nGetLastError = GetLastError();
               if(nGetLastError != 0) 
                  Print("Error closing BUY order : ", ErrorDescription(nGetLastError)); 
         } 
       //----
       if(OrderType() == OP_SELL && n==-1 )
         {
           //----
               RefreshRates();   
               OrderClose(OrderTicket(), OrderLots(),MarketInfo(Symbol(),MODE_ASK), 3, Yellow);
               nGetLastError = GetLastError();
               if(nGetLastError != 0)
                   Print("Error closing SELL order : ", ErrorDescription(nGetLastError));         
         }
     }
  }
//===================================================================+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int Check_for_open_pos()
{
   int ticket,cnt,pos;
   if (OrdersTotal()>0) 
   {
      for(cnt=OrdersTotal()-1;cnt>=0;cnt--)
         {
            OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
            if(OrderMagicNumber()!=MAGICEXP || OrderSymbol()!=Symbol() 
               || OrderCloseTime()!=0 ) continue;
            if(OrderType()==OP_SELL ) pos=-1; 
            if(OrderType()==OP_BUY )  pos=1;
         }
   }
 return(pos);
}
//---------------------------------------------------------------------+
//+------------------------------------------------------------------+ 
//|                                  | 
//| :                                                         | 
//|                                       | 
//| :                                                       | 
//|   source      -                                   | 
//|   dest        -                                    | 
//|   delimeter   -                                       | 
//+------------------------------------------------------------------+ 
int StrSplit(string source, string& dest[], string delimeter = ";") 
{ 
   int cnt = 0; 
   int last_pos = 0; 
   int pos = StringFind(source, delimeter, last_pos); 
    
   while (pos != -1) { 
      ArrayResize(dest, cnt + 1); 
      dest[cnt] = StringSubstr(source, last_pos, pos - last_pos); 
      cnt++; 
      last_pos = pos + 1; 
      pos = StringFind(source, delimeter, last_pos); 
   } 
   if (last_pos != 0 && last_pos < StringLen(source)){    
      ArrayResize(dest, cnt + 1); 
      dest[cnt] = StringSubstr(source, last_pos, StringLen(source) - last_pos); 
      cnt++; 
   } 
   return (cnt); 
}
//====================================================================+
/*/
//+------------------------------------------------------------------+
//|                                                 |
//+------------------------------------------------------------------+
void bkp()
{
      //     
      //----
            keybd_event(19,0,0,0); //   VK_PAUSE=19  0x13
            keybd_event(19,0,KEYEVENTF_KEYUP,0); //  
      //---
      return;
}

*/


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int ts()
{
 double Patr=9;
 double Prange=5;
 double Kstop=1.13;
 double kts=2;
 double Vts=2;

 double cnt=0,ValATR=0,hi=0,lo=0,SL=0,TS=0,prevBars=0;



  int i,mode,ticket,total;

  if (prevBars!=Bars) 
  {
    ValATR=0;
    for(i=1; i<=Patr; i++) { if(i<=Patr) { ValATR+=High[i]-Low[i]; } }
    ValATR=ValATR/Patr;
     
    hi=iHigh(NULL,60,Highest(NULL,60,MODE_HIGH,Prange,Prange)); 
    lo=iLow(NULL,60,Lowest(NULL,60,MODE_LOW,Prange,Prange)); 
 
    if (Vts==1)  {TS=kts*ValATR; SL=Kstop*ValATR;}
    if (Vts==2)  {TS=(hi-lo);    SL=Kstop*(hi-lo);}
    prevBars = Bars;
  }

  if (Vts<1 || Vts>2)  return(0);

//-------------------------------------------------------

  for (cnt=0; cnt<=OrdersTotal(); cnt++)
  {
    OrderSelect(cnt,SELECT_BY_POS);
    mode=OrderType();
    if(OrderSymbol()==Symbol())
    {
//First Stop---------------------------------
      if (mode==OP_BUY && OrderStopLoss()== 0)
      {
        OrderModify(OrderTicket(),OrderOpenPrice(),Low[0]-SL,OrderTakeProfit(),0,CLR_NONE);
        //PlaySound("expert.wav");
        return(0);
      }

      if (mode==OP_SELL && OrderStopLoss()==0)
      {
        OrderModify(OrderTicket(),OrderOpenPrice(),High[0]+SL,OrderTakeProfit(),0,CLR_NONE);
        //PlaySound("expert.wav");
        return(0);
      }
//Main Trailing-------------------------------
      if ((mode==OP_BUY && High[0]-OrderOpenPrice()>TS && OrderStopLoss()<High[0]-TS) || OrderStopLoss()==0)
      {
        OrderModify(OrderTicket(),OrderOpenPrice(),High[0]-TS,OrderTakeProfit(),0,CLR_NONE);
        //PlaySound("expert.wav");
        return(0);
      }

      if ((mode==OP_SELL && OrderOpenPrice()-Low[0]>TS && OrderStopLoss()>Low[0]+TS) || OrderStopLoss()==0)
      {
        OrderModify(OrderTicket(),OrderOpenPrice(),Low[0]+TS,OrderTakeProfit(),0,CLR_NONE);
        //PlaySound("expert.wav");
        return(0);
      }
    }
  }

  return;
}

